| The Gaudi Framework v29r1 (5cd95fa2)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Attributes | List of all members
RootHistCnv::RFileCnv Class Reference

NTuple converter class definition. More...

`#include <src/RFileCnv.h>`

Inheritance diagram for RootHistCnv::RFileCnv:
[legend]
Collaboration diagram for RootHistCnv::RFileCnv:
[legend]

## Public Member Functions
StatusCode | initialize () override
| Initialise. More...
StatusCode | createObj (IOpaqueAddress *pAddress, DataObject *&refpObject) override
| Create the transient representation of an object. More...
StatusCode | createRep (DataObject *pObject, IOpaqueAddress *&refpAddress) override
| Convert the transient object to the requested representation. More...
StatusCode | updateRep (IOpaqueAddress *pAddress, DataObject *pObject) override
| Convert the transient object to the requested representation. More...
| RFileCnv (ISvcLocator *svc)
| Standard constructor. More...
| ~RFileCnv () override=default
| Standard destructor. More...
Public Member Functions inherited from RootHistCnv::RDirectoryCnv
StatusCode | createObj (IOpaqueAddress *pAddr, DataObject *&refpObj) override
| Create the transient representation of an object. More...
StatusCode | fillObjRefs (IOpaqueAddress *pAddr, DataObject *refpObj) override
| Update the transient object from the other representation. More...
StatusCode | createRep (DataObject *pObj, IOpaqueAddress *&refpAddr) override
| Convert the transient object to the requested representation. More...
StatusCode | updateRep (IOpaqueAddress *pAddr, DataObject *pObject) override
| Convert the transient object to the requested representation. More...
| RDirectoryCnv (ISvcLocator *svc)
| Standard constructor. More...
| RDirectoryCnv (ISvcLocator *svc, const CLID &clid)
| Standard constructor. More...
| ~RDirectoryCnv () override=default
| Standard destructor. More...
Public Member Functions inherited from RootHistCnv::RConverter
StatusCode | createRep (DataObject *pObj, IOpaqueAddress *&refpAddr) override
| Convert the transient object to the requested representation. More...
long | repSvcType () const override
StatusCode | error (const std::string &msg)
StatusCode | regTFile (const std::string, const TFile *)
StatusCode | findTFile (const std::string, TFile *&)
std::string | diskDirectory (const std::string &loc)
std::string | directory (const std::string &loc)
void | setDirectory (const std::string &loc)
void | setDiskDirectory (const std::string &loc)
StatusCode | createDirectory (const std::string &loc)
StatusCode | createDiskDirectory (const std::string &loc)
std::string | getDirectory ()
std::string | convertId (const std::string &) const
Public Member Functions inherited from Converter
StatusCode | initialize () override
| Initialize the converter. More...
StatusCode | finalize () override
| Initialize the converter. More...
StatusCode | setDataProvider (IDataProviderSvc *svc) override
| Set Data provider service. More...
SmartIF< IDataProviderSvc > & | dataProvider () const override
| Get Data provider service. More...
StatusCode | setConversionSvc (IConversionSvc *svc) override
| Set conversion service the converter is connected to. More...
SmartIF< IConversionSvc > & | conversionSvc () const override
| Get conversion service the converter is connected to. More...
StatusCode | setAddressCreator (IAddressCreator *creator) override
| Set address creator facility. More...
SmartIF< IAddressCreator > & | addressCreator () const override
| Retrieve address creator facility. More...
const CLID & | objType () const override
| Retrieve the class type of objects the converter produces. More...
virtual long | i_repSvcType () const
| Retrieve the class type of the data store the converter uses. More...
StatusCode | createObj (IOpaqueAddress *pAddress, DataObject *&refpObject) override
| Create the transient representation of an object. More...
StatusCode | fillObjRefs (IOpaqueAddress *pAddress, DataObject *pObject) override
| Resolve the references of the created transient object. More...
StatusCode | updateObj (IOpaqueAddress *pAddress, DataObject *refpObject) override
| Update the transient object from the other representation. More...
StatusCode | updateObjRefs (IOpaqueAddress *pAddress, DataObject *pObject) override
| Update the references of an updated transient object. More...
StatusCode | createRep (DataObject *pObject, IOpaqueAddress *&refpAddress) override
| Convert the transient object to the requested representation. More...
StatusCode | fillRepRefs (IOpaqueAddress *pAddress, DataObject *pObject) override
| Resolve the references of the converted object. More...
StatusCode | updateRep (IOpaqueAddress *pAddress, DataObject *pObject) override
| Update the converted representation of a transient object. More...
StatusCode | updateRepRefs (IOpaqueAddress *pAddress, DataObject *pObject) override
| Update the references of an already converted object. More...
| Converter (long storage_type, const CLID &class_type, ISvcLocator *svc=0)
| Standard Constructor. More...
template<class T >
StatusCode | service (const std::string &name, T *&psvc, bool createIf=false) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &type, const std::string &name, T *&psvc) const
| Access a service by name, type creating it if it doesn't already exist. More...
SmartIF< IService > | service (const std::string &name, const bool createIf=true) const
| Return a pointer to the service identified by name (or "type/name") More...
Public Member Functions inherited from implements< IConverter >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
| implements ()=default
| Default constructor. More...
| implements (const implements &)
| Copy constructor (zero the reference count) More...
implements & | operator= (const implements &)
| Assignment operator (do not touch the reference count). More...
| ~implements () override=default
| Virtual destructor. More...
unsigned long | addRef () override
| Reference Interface instance. More...
unsigned long | release () override
| Release Interface instance. More...
unsigned long | refCount () const override
| Current reference count. More...
Public Member Functions inherited from extend_interfaces< Interfaces... >
| ~extend_interfaces () override=default
| Virtual destructor. More...

## Static Public Member Functions
static const CLID & | classID ()
| Inquire class type. More...
Static Public Member Functions inherited from RootHistCnv::RDirectoryCnv
static const CLID & | classID ()
| Inquire class type. More...
Static Public Member Functions inherited from RootHistCnv::RConverter
static long | storageType ()
| Inquire storage type. More...

## Protected Attributes
TFile * | rfile
| Pointer to ROOT file. More...
std::string | m_compLevel
| Compression setting, property RFileCnv.GlobalCompression. More...
Protected Attributes inherited from implements< IConverter >
std::atomic_ulong | m_refCount
| Reference counter. More...

## Additional Inherited Members
Public Types inherited from Converter
typedef Gaudi::PluginService::Factory< IConverter *, ISvcLocator * > | Factory
Public Types inherited from implements< IConverter >
using | base_class = implements< Interfaces... >
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces... >
| Typedef to the base of this class. More...
using | iids = typename extend_interfaces_base::ext_iids
Public Types inherited from extend_interfaces< Interfaces... >
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids... >::type
| take union of the ext_iids of all Interfaces... More...
Protected Member Functions inherited from RootHistCnv::RConverter
| RConverter (const CLID &clid, ISvcLocator *svc)
| Standard constructor. More...
| ~RConverter () override=default
| Standard destructor. More...
virtual StatusCode | readObject (IOpaqueAddress *pAddr, DataObject *&refpObj)
| Create the transient representation of an object. More...
virtual TObject * | createPersistent (DataObject *pObj)
| Create the persistent representation of an object. More...
StatusCode | createAddress (DataObject *pObject, TDirectory *pDir, TObject *pTObject, IOpaqueAddress *&refpAddr)
| Create address of the transient object according to the requested representation. More...
StatusCode | createAddress (const std::string &rzdir, const CLID &clid, long id, TObject *pTobj, IOpaqueAddress *&refpAddress)
StatusCode | createAddress (const std::string &rzdir, const CLID &clid, const std::string &title, TObject *pTobj, IOpaqueAddress *&refpAddress)
TDirectory * | changeDirectory (DataObject *pObject)
| Switch to object directory (=Parent directory) More...
Protected Member Functions inherited from Converter
| ~Converter () override=default
| Standard Destructor. More...
SmartIF< ISvcLocator > & | serviceLocator () const
| Retrieve pointer to service locator. More...
SmartIF< IMessageSvc > & | msgSvc () const
| Retrieve pointer to message service. More...
SmartIF< IDataManagerSvc > & | dataManager () const
| Get Data Manager service. More...

## Detailed Description

NTuple converter class definition.

- Major cleanup and debugging for Gaudi v9
- Removal of all static storage

Author
  Charles Leggett
  Markus Frank

Definition at line 23 of file RFileCnv.h.

## Constructor & Destructor Documentation

RootHistCnv::RFileCnv::RFileCnv | ( | ISvcLocator * | svc | ) |

Standard constructor.

Definition at line 25 of file RFileCnv.cpp.

25 : RDirectoryCnv( svc, classID() ) {}
RootHistCnv::RFileCnv::classID
static const CLID & classID()
Inquire class type.
Definition: RFileCnv.h:40
RootHistCnv::RDirectoryCnv::RDirectoryCnv
RDirectoryCnv(ISvcLocator *svc)
Standard constructor.
Definition: RDirectoryCnv.h:31

RootHistCnv::RFileCnv::~RFileCnv | ( |  | ) |
| override default

Standard destructor.

## Member Function Documentation

static const CLID& RootHistCnv::RFileCnv::classID | ( |  | ) |
| inline static

Inquire class type.

Definition at line 40 of file RFileCnv.h.

40 { return CLID_NTupleFile; }

StatusCode RootHistCnv::RFileCnv::createObj | ( | IOpaqueAddress * | pAddress,
|  | DataObject *& | refpObject
| ) |  |
| override

Create the transient representation of an object.

Definition at line 42 of file RFileCnv.cpp.

44 {
45 MsgStream log( msgSvc(), "RFileCnv" );
46 unsigned long* ipar = (unsigned long*)pAddress->ipar();
47 char mode[2] = {char( ipar[1] ), 0};
48
49 std::string fname = pAddress->par()[0]; // Container name
50 std::string ooname = pAddress->par()[1]; // Object name
51
52 const std::string* spar = pAddress->par();
53 // Strip of store name to get the top level RZ directory
54 std::string oname = spar[1].substr( spar[1].find( "/", 1 ) + 1 );
55
56 // Protect against multiple instances of TROOT
57 if ( !gROOT ) {
58 static TROOT root( "root", "ROOT I/O" );
59 // gDebug = 99;
60 } else {
61 log << MSG::VERBOSE << "ROOT already initialized, debug = " << gDebug << endmsg;
62 }
63
64 // Determine access mode:
65
66 if ( mode[0] == 'O' ) {
67
68 if ( findTFile( ooname, rfile ).isFailure() ) {
69
70 log << MSG::INFO << "opening Root file \"" << fname << "\" for reading" << endmsg;
71
72 rfile = TFile::Open( fname.c_str(), "READ" );
73 if ( rfile && rfile->IsOpen() ) {
74 regTFile( ooname, rfile ).ignore();
75
76 ipar[0] = (unsigned long)rfile;
77 NTuple::File* pFile = new NTuple::File( objType(), fname, oname );
78 pFile->setOpen( true );
79 refpObject = pFile;
80
81 return StatusCode::SUCCESS;
82
83 } else {
84 log << MSG::ERROR << "Couldn't open \"" << fname << "\" for reading" << endmsg;
85 return StatusCode::FAILURE;
86 }
87
88 } else {
89 log << MSG::DEBUG << "Root file \"" << fname << "\" already opened" << endmsg;
90 return StatusCode::SUCCESS;
91 }
92
93 } else if ( mode[0] == 'U' ) {
94
95 log << MSG::INFO << "opening Root file \"" << fname << "\" for updating" << endmsg;
96
97 log << MSG::ERROR << "don't know how to do this yet. Aborting." << endmsg;
98 exit( 1 );
99
100 } else if ( mode[0] == 'N' ) {
101
102 log << MSG::INFO << "opening Root file \"" << fname << "\" for writing";
103 if ( !m_compLevel.empty() ) {
104 log << ", CompressionLevel='" << m_compLevel << "'";
105 }
106 log << endmsg;
107
108 rfile = TFile::Open( fname.c_str(), "RECREATE", "Gaudi Trees" );
109 if ( !( rfile && rfile->IsOpen() ) ) {
110 log << MSG::ERROR << "Could not open file " << fname << " for writing" << endmsg;
111 return StatusCode::FAILURE;
112 }
113 if ( !m_compLevel.empty() ) {
114 const RootCompressionSettings settings( m_compLevel );
115 rfile->SetCompressionSettings( settings.level() );
116 }
117
118 regTFile( ooname, rfile ).ignore();
119
120 log << MSG::DEBUG << "creating ROOT file " << fname << endmsg;
121
122 ipar[0] = (unsigned long)rfile;
123 NTuple::File* pFile = new NTuple::File( objType(), fname, oname );
124 pFile->setOpen( true );
125 refpObject = pFile;
126 return StatusCode::SUCCESS;
127
128 } else {
129
130 log << MSG::ERROR << "Uknown mode to access ROOT file" << endmsg;
131 return StatusCode::FAILURE;
132 }
133
134 return StatusCode::FAILURE;
135 }
MsgStream
Definition of the MsgStream class used to transmit messages.
Definition: MsgStream.h:24
StatusCode::SUCCESS
Definition: StatusCode.h:31
std::string::empty
T empty(T...args)
NTuple::File::setOpen
void setOpen(bool flag)
Set "open" flag.
Definition: NTuple.h:1041
RootHistCnv::RFileCnv::rfile
TFile * rfile
Pointer to ROOT file.
Definition: RFileCnv.h:49
StatusCode::FAILURE
Definition: StatusCode.h:31
Converter::objType
const CLID & objType() const override
Retrieve the class type of objects the converter produces.
Definition: Converter.cpp:14
MSG::DEBUG
Definition: IMessageSvc.h:16
Converter::msgSvc
SmartIF< IMessageSvc > & msgSvc() const
Retrieve pointer to message service.
Definition: Converter.cpp:103
RootHistCnv::RConverter::regTFile
StatusCode regTFile(const std::string, const TFile *)
Definition: RConverter.cpp:271
RootHistCnv::RConverter::findTFile
StatusCode findTFile(const std::string, TFile *&)
Definition: RConverter.cpp:286
MSG::VERBOSE
Definition: IMessageSvc.h:16
IOpaqueAddress::par
virtual const std::string * par() const =0
Retrieve String parameters.
std::string
STL class.
IOpaqueAddress::ipar
virtual const unsigned long * ipar() const =0
Access to generic link parameters.
std::exit
T exit(T...args)
RootHistCnv::RFileCnv::m_compLevel
std::string m_compLevel
Compression setting, property RFileCnv.GlobalCompression.
Definition: RFileCnv.h:50
std::find
T find(T...args)
std::string::c_str
T c_str(T...args)
MSG::ERROR
Definition: IMessageSvc.h:16
std::string::substr
T substr(T...args)
gaudiComponentHelp.root
root
Definition: gaudiComponentHelp.py:18
StatusCode::ignore
void ignore() const
Definition: StatusCode.h:109
MSG::INFO
Definition: IMessageSvc.h:16
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209
NTuple::File
Small class representing an N tuple file in the transient store.
Definition: NTuple.h:1002
Gaudi.Configuration.log
log
Definition: Configuration.py:13

StatusCode RootHistCnv::RFileCnv::createRep | ( | DataObject * | pObject,
|  | IOpaqueAddress *& | refpAddress
| ) |  |
| override

Convert the transient object to the requested representation.

Definition at line 138 of file RFileCnv.cpp.

140 {
141 refpAddress = pObject->registry()->address();
142 return RFileCnv::updateRep( refpAddress, pObject );
143 }
RootHistCnv::RFileCnv::updateRep
StatusCode updateRep(IOpaqueAddress *pAddress, DataObject *pObject) override
Convert the transient object to the requested representation.
Definition: RFileCnv.cpp:146
DataObject::registry
IRegistry * registry() const
Get pointer to Registry.
Definition: DataObject.h:72
IRegistry::address
virtual IOpaqueAddress * address() const =0
Retrieve opaque storage address.

StatusCode RootHistCnv::RFileCnv::initialize | ( |  | ) |
| override

Initialise.

Definition at line 28 of file RFileCnv.cpp.

29 {
30 // Set compression level property ...
31 ISvcLocator* svcLoc = Gaudi::svcLocator();
32 auto jobSvc = svcLoc->service<IJobOptionsSvc>( "JobOptionsSvc" );
33 auto prop = jobSvc->getClientProperty( "RFileCnv", "GlobalCompression" );
34 if ( prop ) m_compLevel = prop->toString();
35
36 // initialise base class
37 return RDirectoryCnv::initialize();
38 }
ISvcLocator
The ISvcLocator is the interface implemented by the Service Factory in the Application Manager to loc...
Definition: ISvcLocator.h:25
Converter::initialize
StatusCode initialize() override
Initialize the converter.
Definition: Converter.cpp:44
ISvcLocator::service
StatusCode service(const Gaudi::Utils::TypeNameString &name, T *&svc, bool createIf=true)
Templated method to access a service by name.
Definition: ISvcLocator.h:79
IJobOptionsSvc
Main interface for the JobOptions service.
Definition: IJobOptionsSvc.h:20
Gaudi::svcLocator
GAUDI_API ISvcLocator * svcLocator()
RootHistCnv::RFileCnv::m_compLevel
std::string m_compLevel
Compression setting, property RFileCnv.GlobalCompression.
Definition: RFileCnv.h:50
IJobOptionsSvc::getClientProperty
virtual const Gaudi::Details::PropertyBase * getClientProperty(const std::string &client, const std::string &name) const =0
Get a property for a client.

StatusCode RootHistCnv::RFileCnv::updateRep | ( | IOpaqueAddress * | pAddress,
|  | DataObject * | pObject
| ) |  |
| override

Convert the transient object to the requested representation.

Definition at line 146 of file RFileCnv.cpp.

148 {
149 MsgStream log( msgSvc(), "RFileCnv" );
150 std::string ooname = pAddress->par()[1];
151
152 NTuple::File* pFile = dynamic_cast<NTuple::File*>( pObject );
153 if ( pFile && pFile->isOpen() ) {
154
155 unsigned long* ipar = (unsigned long*)pAddress->ipar();
156 if ( findTFile( ooname, rfile ).isFailure() ) {
157 log << MSG::ERROR << "Problems closing TFile " << ooname << endmsg;
158 return StatusCode::FAILURE;
159 }
160
161 rfile->Write( nullptr, TObject::kOverwrite );
162 if ( log.level() <= MSG::INFO ) {
163 log << MSG::INFO << "dumping contents of " << ooname << endmsg;
164 rfile->Print();
165 }
166
167 /*
168 * MetaData
169 * Ana Trisovic
170 * March 2015
171 * */
172 SmartIF<IMetaDataSvc> mds;
173 mds = serviceLocator()->service( "Gaudi::MetaDataSvc", false );
174 // auto mds = service<IMetaDataSvc>("MetaDataSvc", false);
175 if ( mds ) {
176 std::map<std::string, std::string> m_metadata = mds->getMetaDataMap();
177 if ( !rfile->WriteObject( &m_metadata, "info" ) ) {
178 return StatusCode::FAILURE;
179 }
180 }
181 /* */
182
183 rfile->Close();
184 delete rfile;
185
186 ipar[0] = 0;
187 pFile->setOpen( false );
188 return StatusCode::SUCCESS;
189
190 } else {
191 log << MSG::ERROR << "TFile " << ooname << " is not open" << endmsg;
192 }
193 return StatusCode::FAILURE;
194 }
MsgStream
Definition of the MsgStream class used to transmit messages.
Definition: MsgStream.h:24
StatusCode::SUCCESS
Definition: StatusCode.h:31
SmartIF
Small smart pointer class with automatic reference counting for IInterface.
Definition: IConverter.h:15
NTuple::File::setOpen
void setOpen(bool flag)
Set "open" flag.
Definition: NTuple.h:1041
RootHistCnv::RFileCnv::rfile
TFile * rfile
Pointer to ROOT file.
Definition: RFileCnv.h:49
StatusCode::FAILURE
Definition: StatusCode.h:31
Converter::msgSvc
SmartIF< IMessageSvc > & msgSvc() const
Retrieve pointer to message service.
Definition: Converter.cpp:103
RootHistCnv::RConverter::findTFile
StatusCode findTFile(const std::string, TFile *&)
Definition: RConverter.cpp:286
IOpaqueAddress::par
virtual const std::string * par() const =0
Retrieve String parameters.
std::map< std::string, std::string >
std::string
STL class.
ISvcLocator::service
StatusCode service(const Gaudi::Utils::TypeNameString &name, T *&svc, bool createIf=true)
Templated method to access a service by name.
Definition: ISvcLocator.h:79
IMetaDataSvc::getMetaDataMap
virtual std::map< std::string, std::string > getMetaDataMap()=0
IOpaqueAddress::ipar
virtual const unsigned long * ipar() const =0
Access to generic link parameters.
NTuple::File::isOpen
bool isOpen() const
Access "open" flag.
Definition: NTuple.h:1043
Converter::serviceLocator
SmartIF< ISvcLocator > & serviceLocator() const
Retrieve pointer to service locator.
Definition: Converter.cpp:100
MSG::ERROR
Definition: IMessageSvc.h:16
MSG::INFO
Definition: IMessageSvc.h:16
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209
NTuple::File
Small class representing an N tuple file in the transient store.
Definition: NTuple.h:1002
Gaudi.Configuration.log
log
Definition: Configuration.py:13

## Member Data Documentation

std::string RootHistCnv::RFileCnv::m_compLevel
| protected

Compression setting, property RFileCnv.GlobalCompression.

Definition at line 50 of file RFileCnv.h.

TFile* RootHistCnv::RFileCnv::rfile
| protected

Pointer to ROOT file.

Definition at line 49 of file RFileCnv.h.

The documentation for this class was generated from the following files:

- RootHistCnv/src/RFileCnv.h
- RootHistCnv/src/RFileCnv.cpp